//+-------------------------------------------------------------------+ 
//|                                          .mq4 | 
//|                                                         TRO, 2007 | 
//|                                modified by Skyline on 23 Nov 2007 | 
//+-------------------------------------------------------------------+ 
#property  copyright "Copyright ? 2007, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 

//---- indicator settings 
#property  indicator_separate_window 
#property  indicator_buffers 4 
#property  indicator_color1  Red 
#property  indicator_color2  Green 
#property  indicator_color3  Orange 


//---- indicator parameters  
//extern int   Threshold       = 20; 

extern int win = 1;
extern int price.x.offset= 250;//250
extern int price.y.offset= -160;//-190
extern bool show.info=true;

extern int   MaxBars         = 960;
extern int   MA_Period       = 200;

extern int   Chart_Period    = PERIOD_H1;


extern color CurrentBarColor = LightGray ; 
extern color ThresholdColor  = LimeGreen; 
extern bool  ShowLabel       = false; 



//---- indicator buffers 
double     RANGEBuffer[]; 
double     RANGEBuffer1[]; 
double     RANGEBuffer2[]; 
double     TempBuffer[]; 

double     MaxRange = 0 ; 
double     MinRange = 0 ; 




//---- buffers
double low[];
double high[];

int uPeriod ;

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 

//---- drawing settings 
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2); 
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2); 
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2); 
   SetIndexStyle(3,DRAW_NONE);    

//---- indicator buffers mapping 

   SetIndexBuffer(0,RANGEBuffer); 
   SetIndexBuffer(1,RANGEBuffer1);  
   SetIndexBuffer(2,RANGEBuffer2); 
   SetIndexBuffer(3,TempBuffer); // non visualizzato 
    
//---- name for DataWindow and indicator subwindow label 
   IndicatorShortName("TRO RANGE INFO"); 
//   SetIndexLabel(0,"TRO ABOVE"); 
//   SetIndexLabel(1,"TRO BELOW"); 
//   SetIndexLabel(2,"TRO MOVING AVERAGE"); 
    
//---- initialization done 
   return(0); 
  } 

int deinit() 
{ 
   ObjectDelete("CurrentBarValue"); 
   ObjectDelete("LabelCurrentBarValue");  
   ObjectDelete("Threshold"); 
   
   
   ObjectDelete("RNG630");
   ObjectDelete("RNG629");
   ObjectDelete("RNG629B");
   ObjectDelete("RNG631");
   ObjectDelete("RNG632");
   ObjectDelete("RNG634");   
}  

//+------------------------------------------------------------------+ 
//| Range                                                            | 
//+------------------------------------------------------------------+ 
int start() 
  { 

    MaxRange = 0 ; 
    MinRange = 999999 ; 

   double HighVal,LowVal; 
   int limit; 
   int counted_bars=IndicatorCounted(); 
    
//---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 
   if(counted_bars<0) return(-1); 
   
//   limit=Bars-counted_bars; 
  
   limit = MaxBars ;  

//---- RANGE counted in the 1-st buffer 
   for(int i=0; i<limit; i++) 
   { 
   
if( Chart_Period != 0 ) { uPeriod = Chart_Period ; } else { uPeriod = 0 ; }  
 
     HighVal  = iHigh(NULL,0,i);        
     LowVal   = iLow(NULL,0,i); 

      
     TempBuffer[i] = (HighVal-LowVal)/Point; 

//     if( TempBuffer[i] > MaxRange ) {MaxRange = TempBuffer[i] ; }

//     if( TempBuffer[i] < MinRange ) {MinRange = TempBuffer[i] ; }  
 
//     if( TempBuffer[i] > high[i+1] ) {high[i] = TempBuffer[i] ; } else { high[i] = high[i+1] ; }

//     if( TempBuffer[i] < low[i+1] ) { low[i] = TempBuffer[i] ; } else { low[i] = low[i+1] ; }
  
 
       
     /* 
     // Draw Threshold line  
     ObjectDelete("Threshold"); 
     ObjectCreate("Threshold", OBJ_HLINE, win_idx, Time[0], Threshold); 
     ObjectSet("Threshold", OBJPROP_COLOR, ThresholdColor); 
     ObjectSet("Threshold", OBJPROP_STYLE, STYLE_SOLID); 
     ObjectSet("Threshold", OBJPROP_WIDTH, 1); 
     ObjectSet("Threshold", OBJPROP_BACK, true); 
      
     // Label for Threshold 
     if ( ShowLabel == true) 
     { 
      ObjectDelete("LabelThreshold"); 
      ObjectCreate("LabelThreshold", OBJ_TEXT, win_idx, Time[0], Threshold); 
      ObjectSet("LabelThreshold", OBJPROP_COLOR, ThresholdColor); 
      ObjectSetText("LabelThreshold", "Threshold",8); 
      ObjectSet("LabelThreshold", OBJPROP_ANGLE, 0); 
     } 
     */ 
   } 

   // Calculate MA of Histograms 
   for(int j=0; j<limit; j++) 
   { 
     RANGEBuffer2[j]  = iMAOnArray(TempBuffer,0,MA_Period,0,MODE_SMA,j); 

     if( TempBuffer[j] > MaxRange ) {MaxRange = TempBuffer[j] ; }
     if( TempBuffer[j] < MinRange ) {MinRange = TempBuffer[j] ; }  

   } 
  
  
    
   // Paint Histograms 
   for ( i=0; i<limit; i++) 
   { 
    if ( TempBuffer[i] >= RANGEBuffer2[i]) { RANGEBuffer1[i] = TempBuffer[i]; } 
    else { RANGEBuffer[i] = TempBuffer[i]; }    
   }  
   
   // Draw Current Bar line value 
   int win_idx=WindowFind("TRO PLOT ACCUMULATOR"); 
   
   double oRange = (iHigh(NULL,0,0)-iLow(NULL,0,0))/Point ;
   
   
/*    
   ObjectDelete("CurrentBarValue"); 
   ObjectCreate("CurrentBarValue", OBJ_HLINE, win_idx, Time[0], (iHigh(NULL,0,0)-iLow(NULL,0,0))/Point); 
   ObjectSet("CurrentBarValue", OBJPROP_COLOR, CurrentBarColor); 
   ObjectSet("CurrentBarValue", OBJPROP_STYLE, STYLE_SOLID); 
   ObjectSet("CurrentBarValue", OBJPROP_WIDTH, 1); 
   ObjectSet("CurrentBarValue", OBJPROP_BACK, true); 
*/     
   // Label per Current Bar Line 
   if ( ShowLabel == true ) 
   { 
   
   
   
     ObjectDelete("LabelCurrentBarValue"); 
     ObjectCreate("LabelCurrentBarValue", OBJ_TEXT, win_idx, Time[0], oRange ); 
     ObjectSet("LabelCurrentBarValue", OBJPROP_COLOR, CurrentBarColor); 
     ObjectSetText("LabelCurrentBarValue", "Current Bar value",8); 
     ObjectSet("LabelCurrentBarValue", OBJPROP_ANGLE, 0);      
   }    
//---- done 


 
//+------------------------------------------------------------------+ 
if (show.info) {    


if ( oRange > RANGEBuffer2[0] ) { color RangeColor = ThresholdColor ; } else { RangeColor = CurrentBarColor   ; }

   ObjectCreate("RNG630", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("RNG630","RANGE", 30, "Arial Bold", Gray);
   ObjectSet("RNG630", OBJPROP_CORNER, 0);
   ObjectSet("RNG630", OBJPROP_XDISTANCE, 760+price.x.offset);
   ObjectSet("RNG630", OBJPROP_YDISTANCE, 160+price.y.offset);
 
   ObjectCreate("RNG629", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("RNG629",DoubleToStr(MaxRange,0), 15, "Arial Bold", Lime);
   ObjectSet("RNG629", OBJPROP_CORNER, 0);
   ObjectSet("RNG629", OBJPROP_XDISTANCE, 770+price.x.offset);
   ObjectSet("RNG629", OBJPROP_YDISTANCE, 197+price.y.offset);
   
   ObjectCreate("RNG629b", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("RNG629b",DoubleToStr( MinRange ,0), 15, "Arial Bold", Crimson);
   ObjectSet("RNG629b", OBJPROP_CORNER, 0);
   ObjectSet("RNG629b", OBJPROP_XDISTANCE, 770+price.x.offset);
   ObjectSet("RNG629b", OBJPROP_YDISTANCE, 260+price.y.offset);                 
                     
   ObjectCreate("RNG631", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("RNG631",DoubleToStr(oRange,0), 40, "Arial Bold", RangeColor );
   ObjectSet("RNG631", OBJPROP_CORNER, 0);
   ObjectSet("RNG631", OBJPROP_XDISTANCE, 800+price.x.offset); // 765
   ObjectSet("RNG631", OBJPROP_YDISTANCE, 210+price.y.offset); 
           
 
   ObjectCreate("RNG632", OBJ_LABEL, win, 0, 0);
   ObjectSetText("RNG632",DoubleToStr(RANGEBuffer2[0],2), 15, "Arial Bold", Orange);
   ObjectSet("RNG632", OBJPROP_CORNER, 0);
   ObjectSet("RNG632", OBJPROP_XDISTANCE, 860+price.x.offset);
   ObjectSet("RNG632", OBJPROP_YDISTANCE, 197+price.y.offset);
                 
   ObjectCreate("RNG634", OBJ_LABEL, win, 0, 0);
   ObjectSetText("RNG634",DoubleToStr( MaxBars ,0), 15, "Arial Bold", Silver);
   ObjectSet("RNG634", OBJPROP_CORNER, 0);
   ObjectSet("RNG634", OBJPROP_XDISTANCE, 860+price.x.offset);
   ObjectSet("RNG634", OBJPROP_YDISTANCE, 260+price.y.offset);    
    
/*   
   ObjectCreate("RNG634a", OBJ_LABEL, win, 0, 0);
   ObjectSetText("RNG634a",DoubleToStr(s,Digits-4), 15, "Arial Bold", Yellow);
   ObjectSet("RNG634a", OBJPROP_CORNER, 0);
   ObjectSet("RNG634a", OBJPROP_XDISTANCE, 900+price.x.offset);
   ObjectSet("RNG634a", OBJPROP_YDISTANCE, 280+price.y.offset);
   
   ObjectCreate("RNG634b", OBJ_LABEL, win, 0, 0);
   ObjectSetText("RNG634b",DoubleToStr(m,Digits-4)+" : "+DoubleToStr(s,Digits-4), 15, "Arial Bold", Yellow);
   ObjectSet("RNG634b", OBJPROP_CORNER, 0);
   ObjectSet("RNG634b", OBJPROP_XDISTANCE, 870+price.x.offset);
   ObjectSet("RNG634b", OBJPROP_YDISTANCE, 280+price.y.offset); 
   
   ObjectCreate("t634b", OBJ_LABEL, win, 0, 0);
   ObjectSetText("t634b","Time Left", 15, "Arial Bold", Gray);
   ObjectSet("t634b", OBJPROP_CORNER, 0);
   ObjectSet("t634b", OBJPROP_XDISTANCE, 765+price.x.offset);
   ObjectSet("t634b", OBJPROP_YDISTANCE, 280+price.y.offset);   
*/
//+------------------------------------------------------------------+  
   WindowRedraw();    
} 
   return(0); 
  } 